diff --git a/gcc/tree-vectorizer.c b/gcc/tree-vectorizer.c
index 8f18fcd..8d6efa7 100644
--- a/gcc/tree-vectorizer.c
+++ b/gcc/tree-vectorizer.c
@@ -83,6 +83,7 @@ along with GCC; see the file COPYING3.  If not see
 
 /* Loop or bb location.  */
 source_location vect_location;
+vect_location_thing_t vect_location_thing;
 
 /* Vector mapping GIMPLE stmt to stmt_vec_info. */
 vec<stmt_vec_info> stmt_vec_info_vec;
@@ -656,6 +657,7 @@ vectorize_loops (void)
 	loop_dist_alias_call = vect_loop_dist_alias_call (loop);
        vectorize_epilogue:
 	vect_location = find_loop_location (loop);
+	vect_location_thing = loop;
         if (LOCATION_LOCUS (vect_location) != UNKNOWN_LOCATION
 	    && dump_enabled_p ())
 	  dump_printf (MSG_NOTE, "\nAnalyzing loop at %s:%d\n",
@@ -782,6 +784,7 @@ vectorize_loops (void)
       }
 
   vect_location = UNKNOWN_LOCATION;
+  vect_location_thing = (gimple *)NULL;
 
   statistics_counter_event (cfun, "Vectorized loops", num_vectorized_loops);
   if (dump_enabled_p ()
@@ -1123,6 +1126,7 @@ increase_alignment (void)
   varpool_node *vnode;
 
   vect_location = UNKNOWN_LOCATION;
+  vect_location_thing = (gimple *)NULL;
   type_align_map = new hash_map<tree, unsigned>;
 
   /* Increase the alignment of all global arrays for vectorization.  */
diff --git a/gcc/tree-vectorizer.h b/gcc/tree-vectorizer.h
index 7e2b00f..b10cca7 100644
--- a/gcc/tree-vectorizer.h
+++ b/gcc/tree-vectorizer.h
@@ -24,6 +24,7 @@ along with GCC; see the file COPYING3.  If not see
 #include "tree-data-ref.h"
 #include "tree-hash-traits.h"
 #include "target.h"
+#include "optimization-records.h"
 
 /* Used for naming of new temporaries.  */
 enum vect_var_kind {
@@ -1383,6 +1384,27 @@ vect_get_scalar_dr_size (struct data_reference *dr)
 /* Source location */
 extern source_location vect_location;
 
+/* FIXME: update this whenever vect_location changes.
+   FIXME: or merge it all together into this class.
+   FIXME: need a non-placeholder name.  */
+class vect_location_thing_t
+{
+ public:
+  vect_location_thing_t () : m_stmt (NULL), m_loop (NULL) {}
+  vect_location_thing_t (gimple *stmt) : m_stmt (stmt), m_loop (NULL) {}
+  vect_location_thing_t (struct loop *loop) : m_stmt (NULL), m_loop (loop) {}
+
+  gimple *m_stmt;
+  struct loop *m_loop;
+};
+
+extern vect_location_thing_t vect_location_thing;
+
+extern void vect_location_writeln (enum opt_record_kind kind,
+				   const char *fmt, ...)
+  ATTRIBUTE_PRINTF_2;
+
+
 /*-----------------------------------------------------------------*/
 /* Function prototypes.                                            */
 /*-----------------------------------------------------------------*/
-- 
1.8.5.3

